﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PaymentEngine;

namespace Payment_Engine_Demo_App
{
    public partial class PairDevice : Form
    {
        private Middleware client;
        private Device device;

        public PairDevice(Middleware mw)
        {
            InitializeComponent();
            client = mw;

        }

        private void PairDevice_Shown(Object sender, EventArgs e)
        {
        }

        
        internal void startRegistration(Action<Device> deviceRegistered)
        {
            Console.WriteLine("startRegistration()");
            try
            {
                setStatus("Sending pairing request to server");
                client.RegisterDevice("Example", (dev) =>
                {
                    Console.WriteLine("Got device key " + dev.DeviceKey);
                    device = dev;
                    lblMain.Text = "Enter \"" + device.PairingCode + "\" on device...";
                    setStatus("Waiting for pairing code to be entered on device");

                    device.OnRegistrationComplete(() =>
                    {
                        Console.WriteLine("Device registered");
                        deviceRegistered(device);
                        if (this.InvokeRequired)
                        {
                            this.Invoke(new MethodInvoker(delegate { this.Close(); }));
                        }
                        else
                        {
                            this.Close();
                        }
                    });

                }, (emw) => {
                    lblStatus.Text = "Error: " + emw.Message;
                });
            }catch(MiddlewareException ex)
            {
                lblStatus.Text = "Error: " + ex.Message;
            }

        }

        private void setStatus(String status)
        {
            if (lblStatus.InvokeRequired)
            {
                lblStatus.Invoke(new MethodInvoker(delegate { lblStatus.Text = status; }));
            }
            else
            {
                lblStatus.Text = status;
            }
        }


        private void btnCancel_Click(object sender, EventArgs e)
        {
            if(device!=null)
            {
                device.OnRegistrationComplete(null);
            }

            Main owner = (Main) Owner;
            owner.PairingCancled();

            this.Close();
        }
    }
}
